[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.118 and 1.129

version 1.118, 2021/12/24 00:46:02 version 1.129, 2021/12/25 04:04:41
Line 40 
Line 40 
 INSTALL=true  INSTALL=true
 LOCALSRC=  LOCALSRC=
   
   unset FTPPID
   unset FWPKGTMP
   REMOVE_LOCALSRC=false
   cleanup() {
           set +o errexit # ignore errors from killing ftp
           [ "${FTPPID:-}" ] && kill -TERM -"$FTPPID" 2>/dev/null
           [ "${FWPKGTMP:-}" ] && rm -rf "$FWPKGTMP"
           "$REMOVE_LOCALSRC" && rm -rf "$LOCALSRC"
   }
   trap cleanup EXIT
   
 tmpdir() {  tmpdir() {
         local _i=1 _dir          local _i=1 _dir
   
Line 57 
Line 68 
 }  }
   
 fetch() {  fetch() {
         local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _pid _exit _error=''          local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit _error=''
   
         # If we're not in the installer,          # If we're not in the installer,
         # we have su(1) and doas(1) is unlikely to be configured.          # we have su(1) and doas(1) is unlikely to be configured.
Line 67 
Line 78 
         "$VERBOSE" && flags=-vm          "$VERBOSE" && flags=-vm
         if [ -x /usr/bin/su ]; then          if [ -x /usr/bin/su ]; then
                 exec /usr/bin/su -s /bin/ksh "$_user" -c \                  exec /usr/bin/su -s /bin/ksh "$_user" -c \
                     "/usr/bin/ftp -D 'Get/Verify' $flags -o- '$_src'" > "$_dst"                      "/usr/bin/ftp -N '${0##/}' -D 'Get/Verify' $flags -o- '$_src'" > "$_dst"
         else          else
                 exec /usr/bin/doas -u "$_user" \                  exec /usr/bin/doas -u "$_user" \
                     /usr/bin/ftp -D 'Get/Verify' $flags -o- "$_src" > "$_dst"                      /usr/bin/ftp -N "${0##/}" -D 'Get/Verify' $flags -o- "$_src" > "$_dst"
         fi          fi
         ) & _pid=$!          ) & FTPPID=$!
         set +o monitor          set +o monitor
   
         trap "kill -TERM '-$_pid' 2>/dev/null; exit 1" EXIT INT QUIT ABRT TERM  
   
         SECONDS=0          SECONDS=0
         _last=0          _last=0
         while kill -0 -"$_pid" 2>/dev/null; do          while kill -0 -"$FTPPID" 2>/dev/null; do
                 if [[ $SECONDS -gt 12 ]]; then                  if [[ $SECONDS -gt 12 ]]; then
                         set -- $( ls -ln "$_dst" 2>/dev/null )                          set -- $( ls -ln "$_dst" 2>/dev/null )
                         if [[ $_last -ne $5 ]]; then                          if [[ $_last -ne $5 ]]; then
Line 87 
Line 96 
                                 SECONDS=0                                  SECONDS=0
                                 sleep 1                                  sleep 1
                         else                          else
                                 kill -INT -"$_pid"                                  kill -INT -"$FTPPID"
                                 _error=" (timed out)"                                  _error=" (timed out)"
                         fi                          fi
                 else                  else
Line 96 
Line 105 
         done          done
   
         set +o errexit          set +o errexit
         wait "$_pid"          wait "$FTPPID"
         _exit=$?          _exit=$?
         set -o errexit          set -o errexit
   
         trap "" EXIT INT QUIT ABRT TERM          unset FTPPID
   
         if [ "$_exit" -ne 0 ]; then          if [ "$_exit" -ne 0 ]; then
                 rm -f "$_dst"                  rm -f "$_dst"
Line 117 
Line 126 
         fi          fi
 }  }
   
 devices_needing_firmware() {  firmware_in_dmesg() {
         local _d _m _line _dmesgtail _last='' _nl=$( echo )          local _d _m _line _dmesgtail _last='' _nl=$( echo )
   
         # When we're not in the installer, the dmesg.boot can          # When we're not in the installer, the dmesg.boot can
Line 153 
Line 162 
   
 installed_firmware() {  installed_firmware() {
         local _pre="$1" _match="$2" _post="$3" _firmware          local _pre="$1" _match="$2" _post="$3" _firmware
         set -A _firmware -- $(          set -sA _firmware -- $(
             set +o noglob              set +o noglob
             grep -Fxl '@option firmware' \              grep -Fxl '@option firmware' \
                 "${DESTDIR}/var/db/pkg/"$_pre"$_match"$_post"/+CONTENTS" \                  "${DESTDIR}/var/db/pkg/"$_pre"$_match"$_post"/+CONTENTS" \
Line 168 
Line 177 
         done          done
 }  }
   
   detect_firmware() {
           local _devices _last='' _d
   
           set -sA _devices -- $(
               firmware_in_dmesg
               for _d in $( installed_firmware '*' '-firmware-' '*' ); do
                   echo "$( firmware_devicename "$_d" )"
               done
           )
   
           [ "${_devices[*]:-}" ] || return 0
           for _d in "${_devices[@]}"; do
                   [[ $_last = $_d ]] && continue
                   echo $_d
                   _last="$_d"
           done
   }
   
 add_firmware () {  add_firmware () {
         local _f="${1##*/}" _pkgname          local _f="${1##*/}" _pkgname
         local _tmpdir="$( tmpdir "${DESTDIR}/var/db/pkg/.firmware" )"          FWPKGTMP="$( tmpdir "${DESTDIR}/var/db/pkg/.firmware" )"
         local flags=-VM          local flags=-VM
         "$VERBOSE" && flags=-vm          "$VERBOSE" && flags=-vm
         ftp -D "Install" "$flags" -o- "file:${1}" |          ftp -N "${0##/}" -D "Install" "$flags" -o- "file:${1}" |
                 tar -s ",^\+,${_tmpdir}/+," \                  tar -s ",^\+,${FWPKGTMP}/+," \
                     -s ",^firmware,${DESTDIR}/etc/firmware," \                      -s ",^firmware,${DESTDIR}/etc/firmware," \
                     -C / -zxphf - "+*" "firmware/*"                      -C / -zxphf - "+*" "firmware/*"
   
         _pkgname="$( sed -n '/^@name /{s///p;q;}' "${_tmpdir}/+CONTENTS" )"          _pkgname="$( sed -n '/^@name /{s///p;q;}' "${FWPKGTMP}/+CONTENTS" )"
         if [ ! "$_pkgname" ]; then          if [ ! "$_pkgname" ]; then
                 echo "Failed to extract name from $1, partial install" 2>&1                  echo "Failed to extract name from $1, partial install" 2>&1
                 rm -rf "$_tmpdir"                  rm -rf "$FWPKGTMP"
                   unset FWPKGTMP
                 return 1                  return 1
         fi          fi
   
         # TODO: Should we mark these so real fw_update can -Drepair?          # TODO: Should we mark these so real fw_update can -Drepair?
         ed -s "${_tmpdir}/+CONTENTS" <<EOL          ed -s "${FWPKGTMP}/+CONTENTS" <<EOL
 /^@comment pkgpath/ -1a  /^@comment pkgpath/ -1a
 @option manual-installation  @option manual-installation
 @option firmware  @option firmware
Line 195 
Line 223 
 w  w
 EOL  EOL
   
         chmod 755 "$_tmpdir"          chmod 755 "$FWPKGTMP"
         mv "$_tmpdir" "${DESTDIR}/var/db/pkg/${_pkgname}"          mv "$FWPKGTMP" "${DESTDIR}/var/db/pkg/${_pkgname}"
           unset FWPKGTMP
 }  }
   
 delete_firmware() {  delete_firmware() {
Line 241 
Line 270 
 }  }
   
 usage() {  usage() {
         echo "usage:  ${0##*/} [-d | -D | -L] [-av] [driver | file ...]"          echo "usage:  ${0##*/} [-d | -D] [-av] [-p path] [driver | file ...]"
         exit 2          exit 2
 }  }
   
 ALL=false  ALL=false
 OPT_D=  OPT_D=
 OPT_L=  while getopts :adDp:v name
 while getopts :adDLv name  
 do  do
        case "$name" in         case "$name" in
        a) ALL=true ;;         a) ALL=true ;;
        d) DELETE=true ;;         d) DELETE=true ;;
        D) OPT_D=true ;;         D) OPT_D=true ;;
        L) OPT_L=true ;;         p) LOCALSRC="$OPTARG" ;;
        v) VERBOSE=true ;;         v) VERBOSE=true ;;
        ?) echo "${0##*/}: unknown option -- -$OPTARG"; usage 2 ;;         :)
              echo "${0##*/}: option requires an argument -- -$OPTARG" >&2
              usage 2
              ;;
          ?)
              echo "${0##*/}: unknown option -- -$OPTARG" >&2
              usage 2
              ;;
        esac         esac
 done  done
 shift $((OPTIND - 1))  shift $((OPTIND - 1))
   
 [ "$OPT_D" ] && [ "$OPT_L" ] && usage 1  if [ "$LOCALSRC" ]; then
           if [[ $LOCALSRC = @(ftp|http?(s))://* ]]; then
                   FWURL="${LOCALSRC}"
                   LOCALSRC=
           else
                   LOCALSRC="${LOCALSRC:#file:}"
                   ! [ -d "$LOCALSRC" ] &&
                       echo "The path must be a URL or an existing directory" >&2 &&
                       exit 2
           fi
   fi
   
   # "Download only" means local dir and don't install
 if [ "$OPT_D" ]; then  if [ "$OPT_D" ]; then
         # "Download only" means local dir and don't install  
         INSTALL=false          INSTALL=false
         LOCALSRC=.          LOCALSRC="${LOCALSRC:-.}"
 elif [ "$OPT_L" ]; then  
         # "Local" means don't download, install from local dir  
         DOWNLOAD=false  
         LOCALSRC=.  
 else  
         LOCALSRC="$( tmpdir "${DESTDIR}/tmp/${0##*/}" )"  
 fi  fi
   
 CFILE="$LOCALSRC/$CFILE"  
   
 if [ -x /usr/bin/id ] && [ "$(/usr/bin/id -u)" != 0 ]; then  if [ -x /usr/bin/id ] && [ "$(/usr/bin/id -u)" != 0 ]; then
         echo "need root privileges" >&2          echo "need root privileges" >&2
         exit 1          exit 1
 fi  fi
   
 set -A devices -- "$@"  set -sA devices -- "$@"
   
 if "$DELETE"; then  if "$DELETE"; then
         [ "$OPT_D" ] || [ "$OPT_L" ] && usage 22          [ "$OPT_D" ] && usage 22
   
         set -A installed          set -A installed
         if [ "${devices[*]:-}" ]; then          if [ "${devices[*]:-}" ]; then
Line 324 
Line 361 
         exit          exit
 fi  fi
   
   if [ ! "$LOCALSRC" ]; then
       LOCALSRC="$( tmpdir "${DESTDIR}/tmp/${0##*/}" )"
       REMOVE_LOCALSRC=true
   fi
   
   CFILE="$LOCALSRC/$CFILE"
   
 if [ "${devices[*]:-}" ]; then  if [ "${devices[*]:-}" ]; then
         "$ALL" && usage 22          "$ALL" && usage 22
 else  else
         "$VERBOSE" && echo -n "Detecting firmware ..."          "$VERBOSE" && echo -n "Detecting firmware ..."
         set -A devices -- $( devices_needing_firmware )          set -sA devices -- $( detect_firmware )
         "$VERBOSE" &&          "$VERBOSE" &&
             { [ "${devices[*]:-}" ] && echo " found." || echo " done." ; }              { [ "${devices[*]:-}" ] && echo " found." || echo " done." ; }
 fi  fi
Line 341 
Line 385 
         set -o noclobber          set -o noclobber
         ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&          ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
             echo "Signature check of SHA256.sig failed" >&2 && exit 1              echo "Signature check of SHA256.sig failed" >&2 && exit 1
   elif [ ! -e "$CFILE" ]; then
           # TODO: We shouldn't need a CFILE if all arguments are files.
           echo "${0##*/}: $CFILE: No such file or directory" >&2
           exit 2
 fi  fi
   
 added=''  added=''

Legend:
Removed from v.1.118  
changed lines
  Added in v.1.129

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>